"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/teeny-conf.ts
var teeny_conf_exports = {};
__export(teeny_conf_exports, {
  default: () => teeny_conf_default
});
module.exports = __toCommonJS(teeny_conf_exports);
var fs = __toESM(require("fs"), 1);
var path = __toESM(require("path"), 1);
var import_write_file_atomic = __toESM(require("write-file-atomic"), 1);
var import_lodash = __toESM(require("lodash.has"), 1);
var import_lodash2 = __toESM(require("lodash.get"), 1);
var import_lodash3 = __toESM(require("lodash.set"), 1);
var import_lodash4 = __toESM(require("lodash.unset"), 1);
var import_lodash5 = __toESM(require("lodash.clonedeep"), 1);
var TeenyConf = class {
  _configPath;
  _defaultConfig;
  _conf;
  constructor(configPath, defaultConfig) {
    if (!configPath)
      throw new TypeError("teenyconf needs a valid configPath");
    this._configPath = path.resolve(configPath);
    this._defaultConfig = defaultConfig;
    if (!fs.existsSync(path.dirname(this._configPath))) {
      fs.mkdirSync(path.dirname(this._configPath));
    }
    try {
      this._conf = JSON.parse(fs.readFileSync(this._configPath).toString());
    } catch (err) {
      this._conf = (0, import_lodash5.default)(this._defaultConfig);
      this.save();
    }
  }
  /**
   * Reload the configuration from file
   */
  reload() {
    this._conf = JSON.parse(fs.readFileSync(this._configPath).toString());
  }
  /**
   * Save current config to its associated file
   */
  save(minify = false) {
    const output = minify ? JSON.stringify(this._conf) : JSON.stringify(this._conf, null, " ");
    import_write_file_atomic.default.sync(this._configPath, output);
  }
  get(key, def) {
    if (key) {
      return (0, import_lodash2.default)(this._conf, key, def);
    }
    return this._conf;
  }
  getx(key, def) {
    if (key) {
      const valueExists = (0, import_lodash.default)(this._conf, key);
      if (valueExists) {
        return (0, import_lodash2.default)(this._conf, key, def);
      }
    }
    throw new Error(`TeenyConf - key "${key}" does not exist in the config.`);
  }
  /**
   * Set/add key/value pair
   */
  set(key, value) {
    (0, import_lodash3.default)(this._conf, key, value);
  }
  /**
   * Delete a key from the configuration
   */
  delete(key) {
    (0, import_lodash4.default)(this._conf, key);
  }
  /**
   * Clear the configuration and rolls it back the default config
   */
  clear() {
    this._conf = (0, import_lodash5.default)(this._defaultConfig);
  }
  /**
   * Check if a key exists
   */
  has(key) {
    return (0, import_lodash.default)(this._conf, key);
  }
};
var teeny_conf_default = TeenyConf;
//# sourceMappingURL=teeny-conf.cjs.map